Index: EcnlProtoTool/trunk/ntshell/src/mbedcall.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/mbedcall.c	(revision 331)
+++ EcnlProtoTool/trunk/ntshell/src/mbedcall.c	(revision 331)
@@ -0,0 +1,394 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ * 
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã®(1)ï½(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
+ *  ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
+ *  å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
+ *      ã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *    (b) åé
+å¸ã®å½¢æ
+ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
+ *        å ±åãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+ *      ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
+ *      ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ãã
+ *      å
+è²¬ãããã¨ï¼
+ * 
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
+ *  ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
+ *  ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
+ *  ã®è²¬ä»»ãè² ããªãï¼
+ * 
+ *  @(#) $Id$
+ */
+#include "shellif.h"
+#include <stdarg.h>
+#include "analogin_api.h"
+#include "gpio_api.h"
+#include "i2c_api.h"
+#include "pwmout_api.h"
+//#include "rtc_api.h"
+#include "serial_api.h"
+#include "us_ticker_api.h"
+#include "wait_api.h"
+#include "../../mbed_api/src/mbedcall.h"
+
+static inline long __exp_analogin_init(struct regs_t *r)
+{
+	analogin_init((analogin_t *)r->a, (PinName)r->b);
+	return 0;
+}
+
+static inline long __exp_analogin_read_u16(struct regs_t *r)
+{
+	return (long)analogin_read_u16((analogin_t *)r->a);
+}
+
+static inline long __exp_gpio_init(struct regs_t *r)
+{
+	gpio_init((gpio_t *)r->a, (PinName)r->b);
+	return 0;
+}
+
+static inline long __exp_gpio_mode(struct regs_t *r)
+{
+	gpio_mode((gpio_t *)r->a, (PinMode)r->b);
+	return 0;
+}
+
+static inline long __exp_gpio_dir(struct regs_t *r)
+{
+	gpio_dir((gpio_t *)r->a, (PinDirection)r->b);
+	return 0;
+}
+
+static inline long __exp_gpio_write(struct regs_t *r)
+{
+	gpio_write((gpio_t *)r->a, (int)r->b);
+	return 0;
+}
+
+static inline long __exp_gpio_read(struct regs_t *r)
+{
+	return (long)gpio_read((gpio_t *)r->a);
+}
+
+static inline long __exp_i2c_start(struct regs_t *r)
+{
+	return (long)i2c_start((i2c_t *)r->a);
+}
+
+static inline long __exp_i2c_stop(struct regs_t *r)
+{
+	return (long)i2c_stop((i2c_t *)r->a);
+}
+
+static inline long __exp_i2c_init(struct regs_t *r)
+{
+	i2c_init((i2c_t *)r->a, (PinName)r->b, (PinName)r->c);
+	return 0;
+}
+
+static inline long __exp_i2c_read(struct regs_t *r)
+{
+	return (long)i2c_read((i2c_t *)r->a, (int)r->b, (char *)r->c, (int)r->d, (int)r->e);
+}
+
+static inline long __exp_i2c_write(struct regs_t *r)
+{
+	return (long)i2c_write((i2c_t *)r->a, (int)r->b, (const char *)r->c, (int)r->d, (int)r->e);
+}
+
+static inline long __exp_i2c_byte_read(struct regs_t *r)
+{
+	return (long)i2c_byte_read((i2c_t *)r->a, (int)r->b);
+}
+
+static inline long __exp_i2c_byte_write(struct regs_t *r)
+{
+	return (long)i2c_byte_write((i2c_t *)r->a, (int)r->b);
+}
+
+static inline long __exp_pin_function(struct regs_t *r)
+{
+	return (long)pin_function((PinName)r->a, (int)r->b);
+}
+
+static inline long __exp_pin_mode(struct regs_t *r)
+{
+	return (long)pin_mode((PinName)r->a, (PinMode)r->b);
+}
+
+static inline long __exp_pwmout_free(struct regs_t *r)
+{
+	pwmout_free((pwmout_t *)r->a);
+	return 0;
+}
+
+static inline long __exp_pwmout_init(struct regs_t *r)
+{
+	pwmout_init((pwmout_t *)r->a, (PinName)r->b);
+	return 0;
+}
+
+static inline long __exp_pwmout_pulsewidth_us(struct regs_t *r)
+{
+	pwmout_pulsewidth_us((pwmout_t *)r->a, (int)r->b);
+	return 0;
+}
+
+static inline long __exp_rtc_init(struct regs_t *r)
+{
+	rtc_init();
+	return 0;
+}
+
+static inline long __exp_rtc_free(struct regs_t *r)
+{
+	rtc_free();
+	return 0;
+}
+
+static inline long __exp_rtc_isenabled(struct regs_t *r)
+{
+	return (long)rtc_isenabled();
+}
+
+static inline long __exp_rtc_read(struct regs_t *r)
+{
+	return (long)rtc_read();
+}
+
+static inline long __exp_rtc_write(struct regs_t *r)
+{
+	rtc_write((time_t)r->a);
+	return 0;
+}
+
+static inline long __exp_serial_baud(struct regs_t *r)
+{
+	serial_baud((serial_t *)r->a, (int)r->b);
+	return 0;
+}
+
+static inline long __exp_serial_init(struct regs_t *r)
+{
+	serial_init((serial_t *)r->a, (PinName)r->b, (PinName)r->c);
+	return 0;
+}
+
+static inline long __exp_serial_readable(struct regs_t *r)
+{
+	return (long)serial_readable((serial_t *)r->a);
+}
+
+static inline long __exp_serial_getc(struct regs_t *r)
+{
+	return (long)serial_getc((serial_t *)r->a);
+}
+
+static inline long __exp_serial_putc(struct regs_t *r)
+{
+	serial_putc((serial_t *)r->a, (int)r->b);
+	return 0;
+}
+
+static inline long __exp_us_ticker_init(struct regs_t *r)
+{
+	us_ticker_init();
+	return 0;
+}
+
+static inline long __exp_us_ticker_read(struct regs_t *r)
+{
+	return (long)us_ticker_read();
+}
+
+static inline long __exp_us_ticker_set_interrupt(struct regs_t *r)
+{
+	us_ticker_set_interrupt((timestamp_t)r->a);
+	return 0;
+}
+
+static inline long __exp_us_ticker_disable_interrupt(struct regs_t *r)
+{
+	us_ticker_disable_interrupt();
+	return 0;
+}
+
+static inline long __exp_us_ticker_clear_interrupt(struct regs_t *r)
+{
+	us_ticker_clear_interrupt();
+	return 0;
+}
+
+static inline long __exp_SD_begin(struct regs_t *r)
+{
+	return (long)SD_begin();
+}
+
+static long __mbedcall(struct regs_t *r)
+{
+	long ret = -ENOSYS;
+
+	shellif_into();
+
+	switch (r->n) {
+	case MBED_analogin_init:
+		ret = __exp_analogin_init(r);
+		break;
+	case MBED_analogin_read_u16:
+		ret = __exp_analogin_read_u16(r);
+		break;
+	case MBED_gpio_init:
+		ret = __exp_gpio_init(r);
+		break;
+	case MBED_gpio_mode:
+		ret = __exp_gpio_mode(r);
+		break;
+	case MBED_gpio_dir:
+		ret = __exp_gpio_dir(r);
+		break;
+	case MBED_gpio_write:
+		ret = __exp_gpio_write(r);
+		break;
+	case MBED_gpio_read:
+		ret = __exp_gpio_read(r);
+		break;
+	case MBED_i2c_start:
+		ret = __exp_i2c_start(r);
+		break;
+	case MBED_i2c_stop:
+		ret = __exp_i2c_stop(r);
+		break;
+	case MBED_i2c_init:
+		ret = __exp_i2c_init(r);
+		break;
+	case MBED_i2c_read:
+		ret = __exp_i2c_read(r);
+		break;
+	case MBED_i2c_write:
+		ret = __exp_i2c_write(r);
+		break;
+	case MBED_i2c_byte_read:
+		ret = __exp_i2c_byte_read(r);
+		break;
+	case MBED_i2c_byte_write:
+		ret = __exp_i2c_byte_write(r);
+		break;
+	case MBED_pin_function:
+		ret = __exp_pin_function(r);
+		break;
+	case MBED_pin_mode:
+		ret = __exp_pin_mode(r);
+		break;
+	case MBED_pwmout_free:
+		ret = __exp_pwmout_free(r);
+		break;
+	case MBED_pwmout_init:
+		ret = __exp_pwmout_init(r);
+		break;
+	case MBED_pwmout_pulsewidth_us:
+		ret = __exp_pwmout_pulsewidth_us(r);
+		break;
+	case MBED_rtc_init:
+		ret = __exp_rtc_init(r);
+		break;
+	case MBED_rtc_free:
+		ret = __exp_rtc_free(r);
+		break;
+	case MBED_rtc_isenabled:
+		ret = __exp_rtc_isenabled(r);
+		break;
+	case MBED_rtc_read:
+		ret = __exp_rtc_read(r);
+		break;
+	case MBED_rtc_write:
+		ret = __exp_rtc_write(r);
+		break;
+	case MBED_serial_baud:
+		ret = __exp_serial_baud(r);
+		break;
+	case MBED_serial_init:
+		ret = __exp_serial_init(r);
+		break;
+	case MBED_serial_readable:
+		ret = __exp_serial_readable(r);
+		break;
+	case MBED_serial_getc:
+		ret = __exp_serial_getc(r);
+		break;
+	case MBED_serial_putc:
+		ret = __exp_serial_putc(r);
+		break;
+	case MBED_us_ticker_init:
+		ret = __exp_us_ticker_init(r);
+		break;
+	case MBED_us_ticker_read:
+		ret = __exp_us_ticker_read(r);
+		break;
+	case MBED_us_ticker_set_interrupt:
+		ret = __exp_us_ticker_set_interrupt(r);
+		break;
+	case MBED_us_ticker_disable_interrupt:
+		ret = __exp_us_ticker_disable_interrupt(r);
+		break;
+	case MBED_us_ticker_clear_interrupt:
+		ret = __exp_us_ticker_clear_interrupt(r);
+		break;
+	case MBED_SD_begin:
+		ret = __exp_SD_begin(r);
+		break;
+	case MBED___enable_irq:
+		ret = 0;
+		break;
+	case MBED___disable_irq:
+		ret = 0;
+		break;
+	default:
+		asm("bkpt #0");
+		break;
+	}
+
+	shellif_outof();
+
+	return ret;
+}
+
+void __attribute__((naked)) __mbedcall_cp_asm()
+{
+	register long sp asm("sp");
+	asm("push	{r0, r1, r2, r3, r4, r5, r7, r12, lr}");
+	__mbedcall((struct regs_t *)sp);
+	asm("add	sp, sp, #4");
+	asm("pop	{r1, r2, r3, r4, r5, r7, r12, pc}");
+}
+
Index: EcnlProtoTool/trunk/ntshell/src/route_cfg.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/route_cfg.c	(revision 321)
+++ EcnlProtoTool/trunk/ntshell/src/route_cfg.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -44,11 +44,23 @@
 #include <netinet/in_var.h>
 
+/* IPv6 に関する定義 */
+
+#ifdef _IP6_CFG
+
+#if NUM_IN6_ROUTE_ENTRY > 0
+
+T_IN6_RTENTRY routing6_tbl[NUM_IN6_ROUTE_ENTRY];
+
+#endif	/* of #if NUM_IN6_ROUTE_ENTRY > 0 */
+
+#endif	/* of #ifdef _IP6_CFG */
+
 /* IPv4 に関する定義 */
 
-#ifdef SUPPORT_INET4
+#ifdef _IP4_CFG
 
 #ifdef SUPPORT_LOOP
 
-T_IN4_RTENTRY routing_tbl[NUM_ROUTE_ENTRY] = {
+T_IN4_RTENTRY routing4_tbl[NUM_IN4_ROUTE_ENTRY] = {
 	{ 0, 0, 0 },
 	};
@@ -58,5 +70,5 @@
 #ifdef SUPPORT_PPP
 
-T_IN4_RTENTRY routing_tbl[NUM_ROUTE_ENTRY] = {
+T_IN4_RTENTRY routing4_tbl[NUM_IN4_ROUTE_ENTRY] = {
 	{ 0, 0, 0 },
 	};
@@ -66,5 +78,5 @@
 #ifdef SUPPORT_ETHER
 
-T_IN4_RTENTRY routing_tbl[NUM_ROUTE_ENTRY] = {
+T_IN4_RTENTRY routing4_tbl[NUM_IN4_ROUTE_ENTRY] = {
 
 	/* 異なる LAN、default gateway による間接配送	*/
@@ -82,15 +94,3 @@
 #endif	/* of #ifdef SUPPORT_ETHER */
 
-#endif	/* of #ifdef SUPPORT_INET4 */
-
-/* IPv6 に関する定義 */
-
-#ifdef SUPPORT_INET6
-
-#if NUM_ROUTE_ENTRY > 0
-
-T_IN6_RTENTRY routing_tbl[NUM_ROUTE_ENTRY] = { };
-
-#endif	/* of #if NUM_ROUTE_ENTRY > 0 */
-
-#endif	/* of #ifdef SUPPORT_INET6 */
+#endif	/* of #ifdef _IP4_CFG */
Index: EcnlProtoTool/trunk/ntshell/src/shellif.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/shellif.h	(revision 331)
+++ EcnlProtoTool/trunk/ntshell/src/shellif.h	(revision 331)
@@ -0,0 +1,249 @@
+/*
+ *  TOPPERS ECHONET Lite Communication Middleware
+ * 
+ *  Copyright (C) 2017 Cores Co., Ltd. Japan
+ * 
+ *  ä¸è¨èä½æ¨©è
+ã¯ï¼ä»¥ä¸ã®(1)ï½(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
+ *  ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
+ *  å¤ã»åé
+å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
+ *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
+ *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
+ *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
+ *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
+ *      è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
+ *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
+ *      ç¨ã§ããªãå½¢ã§åé
+å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
+ *      ã¨ï¼
+ *    (a) åé
+å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
+ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
+ *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
+ *    (b) åé
+å¸ã®å½¢æ
+ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
+ *        å ±åãããã¨ï¼
+ *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
+ *      å®³ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ããå
+è²¬ãããã¨ï¼
+ *      ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
+ *      ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
+ããã³TOPPERSãã­ã¸ã§ã¯ãã
+ *      å
+è²¬ãããã¨ï¼
+ * 
+ *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
+ã
+ *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
+ *  ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
+ *  ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
+ *  ã®è²¬ä»»ãè² ããªãï¼
+ * 
+ *  @(#) $Id$
+ */
+#ifndef SHELLIF_H
+#define SHELLIF_H
+
+#ifdef _MSC_VER
+#include <time.h>
+#endif
+
+#define __NEED_off_t
+#define __NEED_ssize_t
+#define __NEED_size_t
+#define __NEED_mode_t
+#define __NEED_dev_t
+#define __NEED_pid_t
+#define __NEED_gid_t
+#define __NEED_uid_t
+#define __NEED_socklen_t
+#define __NEED_nlink_t
+#define __NEED_blksize_t
+#define __NEED_blkcnt_t
+#define __NEED_ino_t
+#define __NEED_time_t
+#define __NEED_suseconds_t
+#define __NEED_struct_timeval
+#define __NEED_struct_timespec
+#define __NEED_struct_iovec
+#define __NEED_clockid_t
+#define __NEED_socklen_t
+#define __NEED_sa_family_t
+#define __NEED_sigset_t
+
+#include "../musl-1.1.18/include/bits/alltypes.h"
+
+typedef unsigned char cc_t;
+typedef unsigned int speed_t;
+typedef unsigned int tcflag_t;
+
+#define NCCS 32
+
+#include "../musl-1.1.18/include/bits/fcntl.h"
+#include "../musl-1.1.18/include/bits/termios.h"
+#include "../musl-1.1.18/include/bits/stat.h"
+#include "../musl-1.1.18/include/sys/select.h"
+#ifndef _MSC_VER
+#include "../musl-1.1.18/include/time.h"
+#endif
+#include "../musl-1.1.18/include/signal.h"
+#include "../musl-1.1.18/include/stdio.h"
+#include "../musl-1.1.18/include/sys/utsname.h"
+#include "../musl-1.1.18/include/dirent.h"
+#include "../musl-1.1.18/include/bits/ioctl.h"
+#include "../musl-1.1.18/include/fcntl.h"
+#include "../musl-1.1.18/include/bits/errno.h"
+#include "../musl-1.1.18/include/sys/socket.h"
+
+#include <stddef.h>
+#include <stdarg.h>
+
+// time.h
+#define CLOCK_REALTIME 0
+
+// dirent.h
+typedef struct __dirstream DIR;
+
+int shell_getdents(int, struct dirent *, size_t);
+// pool.h
+typedef unsigned long nfds_t;
+
+struct pollfd {
+	int fd;
+	short events;
+	short revents;
+};
+
+int shell_poll(struct pollfd *, nfds_t, int);
+
+#define POLLIN     0x001
+#define POLLOUT    0x004
+#define POLLERR    0x008
+
+// stropts.h
+int shell_ioctl(int, int, void *);
+// unistd.h
+#define STDIN_FILENO  0
+#define STDOUT_FILENO 1
+#define STDERR_FILENO 2
+
+int shell_rmdir(const char *);
+int shell_ftruncate(int, off_t);
+int shell_chdir(const char *);
+char *shell_getcwd(char *, size_t);
+int shell_chroot(const char *);
+int shell_close(int);
+int shell_llseek(int, off_t, off_t *, int);
+int shell_fsync(int);
+ssize_t shell_read(int, void *, size_t);
+int shell_readv(int fd, const struct iovec *iov, int iovcnt);
+ssize_t shell_write(int, const void *, size_t);
+int shell_writev(int fd, const struct iovec *iov, int iovcnt);
+int shell_link(const char *, const char *);
+int shell_unlink(const char *);
+pid_t shell_getpid(void);
+int shell_access(const char *path, int mode);
+// signal.h
+int shell_sigprocmask(int how, const sigset_t *restrict set, sigset_t *restrict old);
+int shell_sigaction(int sig, const struct sigaction *restrict sa, struct sigaction *restrict old);
+// socket.h
+int shell_socket(int, int, int);
+int shell_connect(int, const struct sockaddr *, socklen_t);
+ssize_t shell_send(int, const void *, size_t, int);
+ssize_t shell_sendto(int, const void *, size_t, int, const struct sockaddr *, socklen_t);
+ssize_t shell_sendmsg(int, const struct msghdr *, int);
+int shell_bind(int, const struct sockaddr *, socklen_t);
+int shell_listen(int, int);
+int shell_accept(int, struct sockaddr *__restrict, socklen_t *__restrict);
+ssize_t shell_recv(int, void *, size_t, int);
+ssize_t shell_recvfrom(int, void *__restrict, size_t, int, struct sockaddr *__restrict, socklen_t *__restrict);
+ssize_t shell_recvmsg(int, struct msghdr *, int);
+int shell_getsockopt(int, int, int, void *__restrict, socklen_t *__restrict);
+int shell_setsockopt(int, int, int, const void *, socklen_t);
+int shell_shutdown(int, int);
+// select.h
+int shell_select(int, fd_set *__restrict, fd_set *__restrict, fd_set *__restrict, struct timeval *__restrict);
+// syslog.h
+void vsyslog (int, const char *, va_list);
+// termios.h
+int sio_tcgetattr (int, struct termios *);
+int sio_tcsetattr(int, int, const struct termios *);
+// fcntl.h
+int shell_open(const char *, int, void *arg);
+int shell_fcntl(int fd, int cmd, void *arg);
+// stdio.h
+int shell_rename(const char *, const char *);
+// stat.h
+#define S_IFDIR 0040000
+#define S_IFCHR 0020000
+#define S_IFREG 0100000
+
+#define S_IRUSR 0400
+#define S_IWUSR 0200
+#define S_IRGRP 0040
+#define S_IWGRP 0020
+#define S_IROTH 0004
+#define S_IWOTH 0002
+
+int shell_chmod(const char *, mode_t);
+int shell_mkdir(const char *, mode_t);
+int shell_stat(const char *__restrict, struct stat *__restrict);
+int shell_fstat(int, struct stat *);
+int shell_lstat(const char *__restrict, struct stat *__restrict);
+
+int shell_clock_getres(clockid_t clk_id, struct timespec *res);
+int shell_clock_gettime(clockid_t clk_id, struct timespec *tp);
+int shell_clock_settime(clockid_t clk_id, const struct timespec *tp);
+int shell_gettimeofday(struct timeval *tp, void * tzvp);
+
+void shell_abort();
+void shell_exit(int exitcd);
+void shell_exit_group(int exitcd);
+int shell_kill(int pid, int sig);
+
+void *shell_brk(void *addr);
+void *shell_mmap2(void *start, size_t length, int prot, int flags, int fd, off_t pgoffset);
+// sys/mman.h
+int shell_mprotect(void *addr, size_t len, int prot);
+// TODO
+int shell_madvise(void *, size_t, int);
+int shell_uname(struct utsname *);
+// âââmusl
+
+// arduino.h
+int SD_begin();
+
+char *basename(char *);
+void shellif_into();
+void shellif_outof();
+
+struct regs_t {
+	long a;
+	long b;
+	long c;
+	long d;
+	long e;
+	long f;
+	long n;
+};
+
+void no_implement(const char *text);
+void __mbedcall_cp_asm();
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+void Kernel_StartExternal(int argc, char **argv);
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* SHELLIF_H */
